"use strict";
var http = require('http');
var Promise = require('bluebird');
var debug = require('debug')('jenkins:build');
var buildres = require('./buildresult');
function fromJson(jsonBuild) {
    var newBuild = new Build(jsonBuild.number, jsonBuild.url);
    return newBuild;
}
exports.fromJson = fromJson;
;
var Build = (function () {
    function Build(number, rootUrl) {
        this.number = number;
        this.rootUrl = rootUrl;
    }
    ;
    Build.prototype.getResult = function () {
        var self = this;
        return new Promise(function (resolve, reject) {
            var buildUrl = self.rootUrl + '/api/json';
            http.get(buildUrl, function (res) {
                debug('buildUrl status code: ' + res.statusCode);
                var responseBody = '';
                res.on('data', function (chunk) {
                    responseBody += chunk;
                });
                res.on('end', function () {
                    var json = JSON.parse(responseBody);
                    resolve(buildres.fromJson(json));
                });
            }).on('error', function (err) {
                reject(err);
            });
        });
    };
    return Build;
}());
exports.Build = Build;
;
//# sourceMappingURL=build.js.map