"use strict";
var http = require('http');
var Promise = require('bluebird');
var debug = require('debug')('jenkins:server');
var job = require('./job');
var Server = (function () {
    function Server(url) {
        this.rootUrl = url;
    }
    ;
    Server.prototype.listJobs = function () {
        var self = this;
        return new Promise(function (resolve, reject) {
            var jobListUrl = self.rootUrl + '/api/json';
            http.get(jobListUrl, function (res) {
                debug('listJobs status code: ' + res.statusCode);
                var responseBody = '';
                var jobs = new Array();
                res.on('data', function (chunk) {
                    responseBody += chunk;
                });
                res.on('end', function () {
                    var json = JSON.parse(responseBody);
                    Promise.map(json.jobs, function (jsonJob) { return job.fromJson(jsonJob); }).then(resolve);
                });
            }).on('error', function (err) {
                reject(err);
            });
        });
    };
    ;
    return Server;
}());
exports.Server = Server;
//# sourceMappingURL=server.js.map